/*
 File: cweb_put_k_into_ph.h
 Date and Time: Fri Jan 30 18:55:09 2015 
*/
#ifndef __cweb_put_k_into_ph_h__
#define __cweb_put_k_into_ph_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"
// monolithic grammar: no thread
extern yacco2::State S1_Ccweb_put_k_into_ph;
namespace NS_cweb_put_k_into_ph {
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[1];
};
class Ccweb_put_k_into_ph: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rcweb_put_k_into_phrase_ = 569//start_of_rule_list + 0
    ,rhs1_Rcweb_put_k_into_phrase_ = 1
    ,rhs2_Rcweb_put_k_into_phrase_ = 2
    ,rhs3_Rcweb_put_k_into_phrase_ = 3
    ,rhs4_Rcweb_put_k_into_phrase_ = 4
    ,rhs5_Rcweb_put_k_into_phrase_ = 5
    ,rhs6_Rcweb_put_k_into_phrase_ = 6
    ,rhs7_Rcweb_put_k_into_phrase_ = 7
    ,rhs8_Rcweb_put_k_into_phrase_ = 8
  };
  //no of la sets = 1
  //no of states = 9
  Ccweb_put_k_into_ph();
  ~Ccweb_put_k_into_ph();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[9];
  
    public:
    AST* cweb_marker_t_;
    bool* rules_phrase_seen_;
	void initialize(AST* Cweb_marker_t,bool* Rules_phrase_seen);
  
 };
struct Rcweb_put_k_into_phrase;
struct Rcweb_put_k_into_phrase:public yacco2::CAbs_lr1_sym {
  Rcweb_put_k_into_phrase(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
  void sr7();
  void sr8();
};

} // end of namespace

#endif
